routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



Auth::routes();


Route::get('/', function () {
    // return view('welcome');
    return redirect('/login');
    // return config('app.ref_db');
});

Route::get('change_password', 'Auth\ChangePasswordController@showChangePasswordForm')->name('auth.change_password');
Route::patch('change_password', 'Auth\ChangePasswordController@changePassword')->name('auth.change_password');


Route::middleware(['auth'])->group(function () {
    //
    Route::get('/home', 'HomeController@index')->name('home');

    Route::resource('role', 'RoleController');
    Route::get('role/{role}/hapus', 'RoleController@destroy')->name('role.hapus');
    Route::resource('permission', 'PermissionController');
    Route::get('permission/{role}/hapus', 'PermissionController@destroy')->name('permission.hapus');
    Route::resource('account', 'PenggunaController')->only(['index', 'edit', 'update']);

    Route::resource('pegawai', 'PegawaiController')->except(['destroy']);
    Route::get('pegawai/{role}/hapus', 'PegawaiController@destroy')->name('pegawai.hapus');
    Route::get('apbdes', 'AnggaranController@index')->name('apbdes');
    Route::get('bop', 'AnggaranController@ProyeksiBop')->name('bop');
    Route::get('bop/pdf', 'AnggaranController@ProyeksiBopPdf')->name('bop.pdf');
    Route::get('belanjafisik', 'AnggaranController@belanjaFisik')->name('belanjafisik');
    Route::get('belanjafisik/pdf', 'AnggaranController@belanjaFisikpdf')->name('belanjafisik.pdf');
    Route::get('panjardd', 'AnggaranController@panjarFisikDanaDesa')->name('panjardd');
    Route::get('panjardd/pdf', 'AnggaranController@panjarFisikDanaDesaPdf')->name('panjardd.pdf');
    Route::get('pajak', 'AnggaranController@SektorPajak')->name('pajak');
    Route::get('pajak/pdf', 'AnggaranController@SektorPajakPdf')->name('pajak.pdf');

    Route::resource('pembinaan', 'PembinaanController')->except(['destroy']);
    Route::get('pembinaan/{pembinaan}/hapus', 'PembinaanController@destroy')->name('pembinaan.hapus');
    Route::post('pembinaan/upload', 'PembinaanController@uploadData')->name('pembinaan.upload');


    Route::resource('pembinaanevaluasi', 'pembinaanevaluasiController')->except(['destroy']);
    Route::get('pembinaanevaluasi/{pembinaanevaluasi}/hapus', 'pembinaanevaluasiController@destroy')->name('pembinaanevaluasi.hapus');
    Route::post('pembinaanevaluasi/upload', 'pembinaanevaluasiController@uploadData')->name('pembinaanevaluasi.upload');

    Route::resource('pengawasan', 'PengawasanController')->except(['destroy']);
    Route::get('pengawasan/{pengawasan}/hapus', 'PengawasanController@destroy')->name('pengawasan.hapus');
    Route::post('pengawasan/upload', 'PengawasanController@uploadData')->name('pengawasan.upload');


    Route::resource('pengaduan', 'PengaduanController')->except(['destroy']);
    Route::get('pengaduan/{pengaduan}/hapus', 'PengaduanController@destroy')->name('pengaduan.hapus');
    Route::post('pengaduan/upload', 'PengaduanController@uploadData')->name('pengaduan.upload');

    Route::resource('perintah', 'PerintahPengawasanController')->except(['destroy']);
    Route::get('perintah/{perintah}/hapus', 'PerintahPengawasanController@destroy')->name('perintah.hapus');
    Route::get('perintah/selesai/{perintah}', 'PerintahPengawasanController@selesaiCtrl')->name('perintah.selesai');
    Route::get('resiko', 'FaktorResikoController@index')->name('resiko');
    Route::get('resiko/refresh', 'FaktorResikoController@refreshData')->name('resiko.refresh');
    Route::get('resiko/pdf', 'FaktorResikoController@indexPdf')->name('resiko.pdf');

    Route::get('kecamatan', 'WilayahController@kecamatan')->name('kecamatan');
    Route::get('desa', 'WilayahController@desa')->name('desa');

    Route::get('keuangan', 'KeuanganController@index')->name('keuangan');
});

app/PembinaanEvaluasi.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class PembinaanEvaluasi extends Model
{
    //
       //
       protected $table = 'pembinaan_evaluasi';
       protected $guarded = [];
   
       public function Desa()
       {
           return $this->hasOne('App\Desa', 'Kd_Desa', 'kd_desa');
       }
}

app/Http/Controllers/pembinaanevaluasiController.php
<?php

namespace App\Http\Controllers;

use App\Desa;
use App\Http\Requests\PembinaanRequest;
use App\Imports\PembinaanEvaluasImport;
use App\PembinaanEvaluasi;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use Yajra\DataTables\Facades\DataTables;

class pembinaanevaluasiController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        //
        if ($request->ajax()) {
            $data = PembinaanEvaluasi::with('Desa')->where('tahun',date('Y'));
            return DataTables::of($data)

                ->addColumn('desa', function ($data) {
                    return optional($data->Desa)->Nama_Desa;
                })
                ->addColumn('kecamatan', function ($data) {
                    return optional($data->Desa)->kecamatan->Nama_Kecamatan;
                })
                ->addColumn('action', function ($data) {
                    $btn = '<a href="' . route('pembinaanevaluasi.edit', $data->id) . '" class="btn btn-xs btn-primary"><i class="material-icons">edit</i></a>';
                    $btn .= '<a href="#"   data-url="' . route('pembinaanevaluasi.hapus', $data->id) . '" class="hapus btn btn-xs btn-danger"><i class="material-icons">delete</i></a>';
                    return $btn;
                })
                ->rawColumns(['action', 'desa', 'kecamatan'])
                ->make(true);
        }
        return view('pembinaanevaluasi.index');
    }

    public function create()
    {
        //
        $data = [
            'action' => route('pembinaanevaluasi.store'),
            'method' => 'POST',
            'desa' => Desa::get()
        ];
        return view('pembinaanevaluasi.form', \compact('data'));
        // dd($data['desa'][0]->kecamatan);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(PembinaanRequest $request)
    {
        // Begin Transaction
        DB::beginTransaction();
        try {
            $data = $request->except(['_token', '_method']);

            $fd = PembinaanEvaluasi::where('kd_desa', $request->kd_desa)->where('tahun', $request->tahun);
            if ($fd->count() > 0) {
                //   update
                $fd->update($data);
            } else {
                //    insert
                PembinaanEvaluasi::create($data);
            }

            // Commit Transaction
            DB::commit();
            // Semua proses benar
            $pesan = "Data berhasil di simpan";
            $type = "success";
        } catch (Exception $e) {
            // Rollback Transaction
            DB::rollback();
            // ada yang error
            $pesan = $e->getMessage();
            $type = "warning";
        }

        return redirect('pembinaanevaluasi')->with(['status' => $pesan, 'type' => $type]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $pembinaan = PembinaanEvaluasi::find($id);
        $data = [
            'action' => route('pembinaanevaluasi.update', $id),
            'method' => 'PATCH',
            'desa' => Desa::get(),
            'res' => $pembinaan
        ];
        return view('pembinaanevaluasi.form', \compact('data'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(PembinaanRequest $request, $id)
    {
        //
        // Begin Transaction
        DB::beginTransaction();
        try {
            $pembinaan = PembinaanEvaluasi::find($id);
            $data = $request->except(['_token', '_method']);
            $pembinaan->update($data);
            DB::commit();
            // Semua proses benar
            $pesan = "Data berhasil di update";
            $type = "success";
        } catch (Exception $e) {
            // Rollback Transaction
            DB::rollback();
            // ada yang error
            $pesan = $e->getMessage();
            $type = "warning";
        }

        return redirect('pembinaanevaluasi')->with(['status' => $pesan, 'type' => $type]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $pembinaan = PembinaanEvaluasi::find($id);
        $pembinaan->delete();
        return redirect('pembinaanevaluasi')->with(['status' => 'Berhasil hapus data', 'type' => 'success']);
    }

    public function uploadData(Request $request)
    {
        // dd($request->all());
        $this->validate($request, [
            'file' => 'required|mimes:csv,xls,xlsx'
        ]);
        
        // menangkap file excel
        $file = $request->file('file');
        $res = Excel::import(new PembinaanEvaluasImport, $file);
        dd($res);
    }
}

resources/views/pembinaanevaluasi/form.blade.php
@extends('layouts.admin')
@section('title')
<h2>FORM PEMBINAAN PENGELOLAAN KEUANGAN DESA</h2>
@endsection
@section('content')

<div class="row clearfix">
    <div class="col-md-6">
        <div class="card">
            <div class="body">
                <form action="{{ $data['action'] }}" id="form_validation" method="POST">
                    {{ csrf_field() }}
                    {{ method_field($data['method']) }}


                    <div class="form-group form-float">
                        <div class="form-line {{  $errors->has('tahun')?'error':'' }}">
                            {{-- <input type="text" name="tahun" id="tahun" class="form-control" required value="{{ $data['res']->tahun??old('tahun')??date('Y') }}" readonly> --}}

                            <select id="tahun" name="tahun" class="form-control " required>
                                <?php for ($th = date('Y'); $th >=2020; $th--) { ?>
                                    <option @if(($data['res']->tahun??old('tahun')??date('Y'))==$th ) selected @endif value="{{ $th }}">{{ $th }}</option>
                                <?php } ?>
                            </select>
                            <label class="form-label">Tahun</label>
                        </div>
                        <label class="error">{{ $errors->first('tahun') }}</label>
                    </div>
                    <div class="form-group">
                        <div class="form-line">
                            
                        </div>
                    </div>
                    <div class="form-group form-float">
                        <div class="form-line {{  $errors->has('kd_desa')?'error':'' }}">

                            <select name="kd_desa" id="kd_desa" class="form-control show-tick" data-live-search="true" required>
                                <option value="">Desa</option>
                                @php
                                $selected=old('kd_desa');
                                if(isset($data['res']->kd_desa)){
                                $selected=$data['res']->kd_desa;
                                }
                                @endphp
                                @foreach($data['desa'] as $desa)
                                <option @if($selected==$desa->Kd_Desa) selected @endif value="{{ $desa->Kd_Desa }}">{{ $desa->Nama_Desa }}, {{ $desa->kecamatan->Nama_Kecamatan }}</option>
                                @endforeach
                            </select>
                        </div>
                        <label class="error">{{ $errors->first('kd_desa') }}</label>
                    </div>
                    <div class="form-group form-float">
                        <div class="form-line {{  $errors->has('jumlah')?'error':'' }}">
                            <input type="text" name="jumlah" id="jumlah" class="form-control" required value="{{ $data['res']->jumlah??old('jumlah') }}">
                            <label class="form-label">Resiko</label>
                        </div>
                        <label class="error">{{ $errors->first('jumlah') }}</label>
                    </div>
                    <div class="form-group">
                        <button class="btn btn-success" type="submit"><i class="material-icons">save</i> Simpan</button>
                        <a href="{{ url('pembinaan') }}" class="btn btn-warning"><i class="material-icons">flip_to_back</i> Kembali</a>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>


@endsection
@section('css')
<link href="{{ asset('bsb/plugins/bootstrap-select/css/bootstrap-select.css') }}" rel="stylesheet" />
@endsection
@section('script')
<!-- Select Plugin Js -->
<script src="{{ asset('bsb/plugins/bootstrap-select/js/bootstrap-select.js') }}"></script>
<script src="{{ asset('bsb/plugins/jquery-validation/jquery.validate.js')}}"></script>
<script>
    $(document).ready(function() {
        $('#form_validation').validate({
            rules: {
                'checkbox': {
                    required: true
                },
                'gender': {
                    required: true
                }
            },
            highlight: function(input) {
                $(input).parents('.form-line').addClass('error');
            },
            unhighlight: function(input) {
                $(input).parents('.form-line').removeClass('error');
            },
            errorPlacement: function(error, element) {
                $(element).parents('.form-group').append(error);
            }
        });
    });
</script>
@endsection

resources/views/pembinaanevaluasi/index.blade.php
@extends('layouts.admin')
@section('title')
<h2>PEMBINAAN & Evaluasi
    <div class="pull-right">
        <a href="#" class="btn btn-xs btn-success" data-toggle="modal" data-target="#modal-default"><i class="material-icons">cloud_upload</i> Upload</a>
        <a href="{{ route('pembinaanevaluasi.create')}}" class="btn btn-xs btn-primary"><i class="material-icons">note_add</i> Tambah</a>
    </div>
</h2>


@endsection
@section('content')
<div class="row clearfix">
    <div class="col-lg-12">
        <div class="card">
            <div class="body">
                <div class="table-responsive">
                    <table class="table table-striped" id="table">
                        <thead class="bg-success text-white ">
                            <tr>
                                <th>No</th>
                                <th>Desa</th>
                                <th>Resiko</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="modal fade" id="modal-default">
    <div class="modal-dialog">
        <div class="modal-content">
            <form class="tagForm" id="tag-form" action="{{ route('pembinaanevaluasi.upload') }}" method="post" enctype="multipart/form-data">
                @csrf
                <div class="modal-header">
                    <h4 class="modal-title">Upload Berkas Excel</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <input type="file" name="file" id="file" class="form-control" required>
                    </div>
                    <div class="form-group">
                        <label>Tutorial:</label>
                        <ol>
                            <li>Isi data pada template yang sudah di sediakan</li>
                            <li>Template dapat di unduh dengan cara klik tombol "Template"</li>
                            <li>kolom <b>"KODE"</b> di isi dengan kode desa siskeudes</li>
                            <li>kolom <b>"NILAI"</b> di isi dengan nilai resiko</li>
                        </ol>
                    </div>
                </div>
                <div class="modal-footer justify-content-between">
                    <a href="{{ asset('template_upload.xlsx') }}" class="btn btn-default"><i class="material-icons">attach_file</i> Template</a>
                    <button type="submit" id="tag-form-submit" class="btn btn-primary"><i class="material-icons">cloud_upload</i> Upload</button>
                </div>
            </form>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
@endsection
@section('script')
<script>
    $(document).ready(function() {
        $.fn.dataTableExt.oApi.fnPagingInfo = function(oSettings) {
            return {
                "iStart": oSettings._iDisplayStart,
                "iEnd": oSettings.fnDisplayEnd(),
                "iLength": oSettings._iDisplayLength,
                "iTotal": oSettings.fnRecordsTotal(),
                "iFilteredTotal": oSettings.fnRecordsDisplay(),
                "iPage": Math.ceil(oSettings._iDisplayStart / oSettings._iDisplayLength),
                "iTotalPages": Math.ceil(oSettings.fnRecordsDisplay() / oSettings._iDisplayLength)
            };
        };
        var t = $('#table').DataTable({
            processing: true,
            ordering: false,
            serverSide: false,
            ajax: "{{ url('/pembinaanevaluasi') }}",
            columns: [{
                    data: 'jumlah',
                    name: 'jumlah',
                    classname: 'text-center'
                }, {
                    data: 'desa',
                    name: 'desa',
                    render: function(data, type, row) {
                        var res = data;
                        if (row.kecamatan != null) {
                            res += '<br><code>' + row.kecamatan + '</code>';
                        }

                        return res;
                    }
                },
                {
                    data: 'jumlah',
                    name: 'jumlah',
                },
                {
                    data: 'action',
                    name: 'action',
                    className: 'text-right'
                },
            ],
            "rowCallback": function(row, data, iDisplayIndex) {
                var info = this.fnPagingInfo();
                var page = info.iPage;
                var length = info.iLength;
                var index = page * length + (iDisplayIndex + 1);
                $('td:eq(0)', row).html(index);
            }

        });

        $('#tag-form-submit').on('click', function(e) {
            e.preventDefault();
            loading();


            var data = new FormData(this.form);
            $.ajax({
                type: "POST",
                url: "{{ route('pembinaanevaluasi.upload') }}",
                data: data,
                processData: false,
                contentType: false,
                success: function(response) {
                    // alert(response['response']);
                    swal.close();
                    $('#modal-default').modal('hide');
                    // toastr.success('Dokumen berhasil di import');
                    loadingclose('Dokumen berhasil di import');
                    $('#table').DataTable().ajax.reload();
                },
                error: function() {
                    // alert('Error');
                    loadingclose('error');
                }
            });
            return false;
        });

    });
</script>
@endsection